'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');

var Html = function (_React$Component) {
  _inherits(Html, _React$Component);

  function Html() {
    _classCallCheck(this, Html);

    return _possibleConstructorReturn(this, (Html.__proto__ || Object.getPrototypeOf(Html)).apply(this, arguments));
  }

  _createClass(Html, [{
    key: 'render',
    value: function render() {
      var state = this.props.state;
      var injectedState = 'window.__STATE = ' + JSON.stringify(state) + ';';
      var _props$document = this.props.document,
          title = _props$document.title,
          meta = _props$document.meta,
          link = _props$document.link,
          bodyAttrs = _props$document.bodyAttrs,
          htmlAttrs = _props$document.htmlAttrs;


      try {
        var Helmet = require('react-helmet');
        var helmet = Helmet.renderStatic();
        title = title || helmet.title.toComponent();
        meta = meta || helmet.meta.toComponent();
        link = link || helmet.link.toComponent();
        htmlAttrs = htmlAttrs || helmet.htmlAttributes.toComponent();
        bodyAttrs = bodyAttrs || helmet.bodyAttributes.toComponent();
      } catch (e) {
        // Helmet wasn't given to us...
        // for now, we'll silently skip
      }

      return React.createElement(
        'html',
        _extends({ lang: 'en-gb' }, htmlAttrs),
        React.createElement(
          'head',
          null,
          title,
          meta,
          link,
          React.createElement('meta', { charSet: 'utf-8' }),
          React.createElement('meta', { httpEquiv: 'X-UA-Compatible', content: 'IE=edge' }),
          React.createElement('meta', { name: 'viewport', content: 'width=device-width, initial-scale=1' }),
          React.createElement('meta', { name: 'mobile-web-app-capable', content: 'yes' }),
          React.createElement('link', { href: '/assets/styles.css', rel: 'stylesheet' }),
          React.createElement('link', { rel: 'icon', type: 'image/x-icon', href: '/favicon.ico' }),
          React.createElement('script', { dangerouslySetInnerHTML: { __html: this.props.globals } })
        ),
        React.createElement(
          'body',
          bodyAttrs,
          React.createElement(
            'div',
            { id: 'root' },
            this.props.children
          ),
          React.createElement('script', { dangerouslySetInnerHTML: { __html: injectedState } }),
          React.createElement('script', { src: '/assets/bundle.js' })
        )
      );
    }
  }]);

  return Html;
}(React.Component);

Html.defaultProps = {
  document: {}
};

module.exports = Html;