'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var executeFetchData = require('../helpers/executeFetchData');
var hoistNonReactStatics = require('hoist-non-react-statics');
var SSRConsumer = require('../ssrContext').SSRConsumer;
require('regenerator-runtime/runtime.js');

var ssrFetchData = function ssrFetchData(DecoratedComponent) {
  var _class;

  var ssrFetchData = (0, _reactRouter.withRouter)(_class = function (_React$Component) {
    _inherits(ssrFetchData, _React$Component);

    function ssrFetchData(props) {
      _classCallCheck(this, ssrFetchData);

      var _this = _possibleConstructorReturn(this, (ssrFetchData.__proto__ || Object.getPrototypeOf(ssrFetchData)).call(this, props));

      _this.state = { fetched: false, params: props.match.params };
      _this.loaderRequired = false;
      _this.error = false;
      return _this;
    }

    // static getDerivedStateFromProps (nextProps, prevState) {
    //   if (nextProps && !nextProps.disableFetchData) {
    //     const { params = {} } = prevState

    //     if (Object.keys(params).length > 0 && params !== nextProps.match.params) {
    //       return { fetched: false, params }
    //     }
    //   }

    //   return {
    //     ...nextProps,
    //     ...prevState
    //   }
    // }

    _createClass(ssrFetchData, [{
      key: 'fetchData',
      value: function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
          var props;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  _context.next = 3;
                  return executeFetchData(DecoratedComponent, this.props.match);

                case 3:
                  props = _context.sent;

                  this.clientFetchedProps = props[DecoratedComponent.displayName];
                  this.error = false;
                  this.setState({ fetched: true });
                  _context.next = 14;
                  break;

                case 9:
                  _context.prev = 9;
                  _context.t0 = _context['catch'](0);

                  console.warn('Failed to fetch some props for fetchData. Rendering anyway...', _context.t0);
                  this.error = true;
                  this.setState({ fetched: true });

                case 14:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this, [[0, 9]]);
        }));

        function fetchData() {
          return _ref.apply(this, arguments);
        }

        return fetchData;
      }()
    }, {
      key: 'extractFromWindow',
      value: function extractFromWindow() {
        if (typeof window !== 'undefined') {
          var _ref2 = window.__STATE || {},
              _ref2$_dataFromServer = _ref2._dataFromServerRender,
              _dataFromServerRender = _ref2$_dataFromServer === undefined ? {} : _ref2$_dataFromServer;

          return _dataFromServerRender[DecoratedComponent.displayName];
        }

        return null;
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        if (typeof window === 'undefined') {
          this.loaderRequired = false; // on server...
        }

        return _react2.default.createElement(
          SSRConsumer,
          null,
          function () {
            var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var componentProps = props[DecoratedComponent.displayName] || _this2.clientFetchedProps || _this2.extractFromWindow();

            if (!componentProps && !_this2.loaderRequired) {
              _this2.fetchData();
              _this2.loaderRequired = true;
            }

            var loading = !_this2.state.fetched && _this2.loaderRequired && !_this2.props.disableFetchData;
            var error = _this2.error && !_this2.props.disableFetchData;
            return _react2.default.createElement(DecoratedComponent, _extends({}, _this2.props, componentProps, { loading: loading, error: error, retryFetchData: _this2.fetchData.bind(_this2) }));
          }
        );
      }
    }]);

    return ssrFetchData;
  }(_react2.default.Component)) || _class;

  /** Defines what JSX components we need to fetchData for */


  ssrFetchData.ssrWaitsFor = DecoratedComponent.ssrWaitsFor;
  /** Unique name for this component, to use for checking on window state */
  ssrFetchData.displayName = DecoratedComponent.displayName || DecoratedComponent.name;
  /** Make the static fetchData method available, pass through, as HOCs lose statics */
  ssrFetchData.fetchData = DecoratedComponent.fetchData;

  return hoistNonReactStatics(ssrFetchData, DecoratedComponent);
};

exports.default = ssrFetchData;