'use strict';

var executeFetchData = require('../executeFetchData');

var fetchData = function fetchData(component, match, req, res) {
  var promises = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : [];

  if (component.fetchData) {
    promises.push(executeFetchData(component, match, req, res));
  }

  if (component.ssrWaitsFor) {
    component.ssrWaitsFor.forEach(function (childComponent) {
      promises = fetchData(childComponent || childComponent.WrappedComponent, match, req, res, promises);
    });
  }

  return promises;
};

module.exports = fetchData;